searchNodes=[{"ref":"Query.html","title":"Query","type":"module","doc":"Query aids the use of Ecto in web settings. With it, we can add paging, sorting, and scoping with ease. At its heart, Query lets us build complex queries from our controller params. Example Functionality is conducted through one main function Query.run/4: defmodule App.PostController do use App, :controller @options [ sort_permitted: [&quot;id&quot;, &quot;title&quot;, &quot;inserted_at&quot;], scope_permitted: [&quot;by_title&quot;], scope: {App.Context, :query} ] def index(conn, params) do result = Query.run(Post, Repo, params, @options) render(conn, &quot;index.json&quot;, posts: result) end end Given the controller above, we can now pass the following query options. /posts?sort_by=inserted_at&amp;direction=desc&amp;by_title=test Further documentation to come..."},{"ref":"Query.html#run/4","title":"Query.run/4","type":"function","doc":"Fetches data from the given repository based on the params and options given. This provides an easy way to performing paging, sorting, and scoping all from binary maps - typically given from controller params. Options :page_default - the default page if none is provided - defaults to 1 :page_param - the param key to use for the page - defaults to &quot;page&quot; :limit_default - the default limit if none is provided - defaults to 20 :limit_param - the param key to use for the limit - defaults to &quot;limit&quot; :limit_max - the maximum allowed limit - defaults to 50 :sort_default - the default sort attribute if none is provided - defaults to &quot;id&quot; :sort_param - the param key to use for the sort - defaults to &quot;sort_by&quot; :sort_permitted - a list of permitted attributes that we can sort on :dir_default - the default direction - defaults to &quot;asc&quot; :dir_param - the param key to use for the direction - defaults to &quot;dir&quot; :count - whether or not to fetch the total number of records - defaults to true :count_limit - the maximum number of records to count - defaults to :infinite :count_column - the column used to perform the count on :scope_permitted - a list of permitted params that we can scope on :scope - a {module, function} with an arity of 2, that will be passed an Ecto.Query as well as a map of the permitted scopes. You can then perform custom queries with these params :preloads - a list of preloads that will be applied to the result data Examples iex&gt; Query.run(App.Post, App.Repo) %Query.Result{data: ...results of query, meta: ...paging attributes} iex&gt; Query.run(App.Post, App.Repo, %{&quot;page&quot; =&gt; 2, &quot;sort_by&quot; =&gt; &quot;some_attr&quot;}, sort_permitted: [&quot;some_attr&quot;]) %Query.Result{data: ...results of query, meta: ...paging attributes} iex&gt; Query.run(App.Post, App.Repo, %{&quot;published&quot; =&gt; true}, scope: {App.Context, :with_scope}, scope_permitted: [&quot;published&quot;]) %Query.Result{data: ...results of query, meta: ...paging attributes}"},{"ref":"Query.html#t:option/0","title":"Query.option/0","type":"type","doc":""},{"ref":"Query.html#t:options/0","title":"Query.options/0","type":"type","doc":""},{"ref":"Query.html#t:params/0","title":"Query.params/0","type":"type","doc":""},{"ref":"Query.html#t:t/0","title":"Query.t/0","type":"type","doc":""}]